#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main() {
    ifstream cin("bemo.in");
    ofstream cout("bemo.out");

    int N, M; cin >> N >> M;

    vector< vector<int> > A(N, vector<int>(M)), viz(N, vector<int>(M));
    vector<int> X(N * M + 1), Y(N * M + 1);
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j) {
            int x; cin >> x;
            A[i][j] = x;
            X[x] = i;
            Y[x] = j;
        }

    vector<int> from(M, 0);
    vector<int> to(M, N - 1);

    for (int i = 1; i <= N * M; ++i) {
        int row = X[i];
        int col = Y[i];
        if (row < from[col] || row > to[col])
            continue;

        for (int j = 0; j < col; ++j)
            to[j] = min(to[j], row);
        for (int j = col + 1; j < M; ++j)
            from[j] = max(from[j], row);

		viz[X[i]][Y[i]] = 1;
    }
    
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j)
			if (viz[i][j])
				cout << A[i][j] << " ";
				
	return 0;
}
