#include <cstdio>
#include <set>
using namespace std;

const int NMAX=2005,CHMAX=10005;

int pozX[NMAX*NMAX],pozY[NMAX*NMAX];
set <pair <int,int> > P;
int A[NMAX][NMAX];
int N,M;

char buff[CHMAX];
int poz=CHMAX-1;

inline void read (int &X) {
	while (!('0'<=buff[poz] && buff[poz]<='9'))
	    if (++poz==CHMAX) { 
			poz=0;
			fread (buff,1,CHMAX,stdin);
		}

	X=0;
    while ('0'<=buff[poz] && buff[poz]<='9') {
		X=X*10+buff[poz]-'0';
        if (++poz==CHMAX) { 
			poz=0;
			fread (buff,1,CHMAX,stdin);
		}
	}
}

int main () {
	freopen ("bemo.in","r",stdin);
	freopen ("bemo.out","w",stdout);
	
	read (N); read (M);
	for (int i=1; i<=N; ++i)
		for (int j=1; j<=M; ++j) {
			read (A[i][j]);
			
			pozX[A[i][j]]=i;
			pozY[A[i][j]]=j;
		}
		
	P.insert (make_pair (1,1));
	P.insert (make_pair (N,M));
	for (int i=1; i<=N*M; ++i)
		if (i!=A[1][1] && i!=A[1][1]) {
			set <pair <int,int> > :: iterator it1,it2;
			it2=P.lower_bound (make_pair (pozX[i],pozY[i]));
			it1=--it2; it2++;
			
			if (it1->first<=pozX[i] && pozX[i]<=it2->first && it1->second<=pozY[i] && pozY[i]<=it2->second)
				P.insert (make_pair (pozX[i],pozY[i]));
		}
	
	set <pair <int,int> > :: iterator it;
	for (it=P.begin (); it!=P.end (); ++it)
		printf ("%d ",A[it->first][it->second]);
			
	return 0;
}
