#include <iostream>
#include <fstream>
#include <vector>
#include <cassert>
using namespace std;

const char iname[] = "ausoara.in";
const char oname[] = "ausoara.out";
const int kMaxValue = 1000005;

vector <int> counts(kMaxValue);

int main(void) {
    int num_sets;

    ifstream in(iname);
    assert(in >> num_sets);
    assert(1 <= num_sets && num_sets <= 100);
    for (int i = 0; i < num_sets; ++ i) {
        int set_size;
        assert(in >> set_size); 
        assert(1 <= set_size && set_size <= 1000);
        for (int j = 0; j < set_size; ++ j) {
            int number;
            assert(in >> number);
            assert(1 <= number && number <= 1000000);
            counts[number] ++;
        }
    }

    ofstream out(oname);
    int answer = 0;
    for (int i = 1; i < kMaxValue; ++ i) if (counts[i] == num_sets)
        answer ++;
    out << answer << " ";
    for (int i = 1; i < kMaxValue; ++ i) if (counts[i] == num_sets)
        out << i << " ";
    out.close();
    return 0;
}