#include<stdio.h>
#include<vector>
#include<ctype.h>
#include<algorithm>
using namespace std;

FILE *f = fopen("bemo.in","r");
FILE *g = fopen("bemo.out","w");

typedef struct poz
{
    int x,y;
} ;

typedef struct sol
{
    int x,y, val;
} ;

typedef struct Compare
{
    bool operator() (const sol a,const sol b)
    {
        if(a.x == b.x)
            return a.y < b.y;
        return a.x < b.x;
    }
} ICompare;

#define MaxN 2010
#define MaxS (10*MaxN)
#define INF (1<<29)

int N,M;
int A[MaxN][MaxN];
vector<sol> SolV;
char S[MaxS];

inline int min(int a,int b)
{
    return a < b ? a : b;
}

inline poz take_min(int x,int y,int z,int w)
{
    poz myPoz = {0,0};
    int myMin = INF;

    for(int i=x;i<=z;i++)
        for(int j=y;j<=w;j++)
            if(myMin > A[i][j])
            {
                myPoz.x = i;
                myPoz.y = j;
                myMin = A[i][j];
            }

    return myPoz;
}

inline void bemo(int x,int y,int z,int w)
{
    if(x == z && w == y)
        return ;

    poz myPoz = take_min(x,y,z,w); 

    if(A[myPoz.x][myPoz.y] == INF)
        return ;

    sol Sol;
    Sol.x = myPoz.x;
    Sol.y = myPoz.y;
    Sol.val = A[myPoz.x][myPoz.y];

    SolV.push_back(Sol);

    A[myPoz.x][myPoz.y] = INF;

    bemo (x , y , myPoz.x , myPoz.y);
    bemo (myPoz.x , myPoz.y , z , w);
}

void citire(void)
{
    int poz = 0;
    fscanf(f,"%d %d\n",&N,&M);
    for(int i=1;i<=N;i++)
    {
        fgets(S,sizeof(S),f);
        int k = 0;

        for(int j=1;j<=M;j++)
        {
            for(;!isdigit(S[k]);k++);
            for(;isdigit(S[k]);A[i][j] = A[i][j] * 10 + S[k++] - '0');
        }
    }
}

int main()
{
    citire();

    A[0][0] = INF;

    bemo(1,1,N,M);

    sort(SolV.begin(),SolV.end(),ICompare());

    for(int i=0;i<SolV.size();i++)
        fprintf(g,"%d ",SolV[i].val);
}
