//Brut - O(1) flip
//     - O(N) query
#include <cstdio>
#include <cassert>
#include <vector>

using namespace std;

#define MaxN 250100

int N,Q;
vector<int> A[MaxN];
vector<int> B[MaxN];
int T[MaxN],Val[MaxN],viz[MaxN];

void citire(void)
{
    int a,b;

    scanf("%d %d",&N,&Q);
    for(int i=1;i<N;i++)
    {
        assert(scanf("%d %d",&a,&b) == 2);
        assert(1 <= a && a <= N);
        assert(1 <= b && b <= N);
        assert(a != b);
        A[a].push_back(b);
        A[b].push_back(a);
    }
}

void DF(int nod)
{
    viz[nod] = 1;

    for(int i=0;i<A[nod].size();i++)
        if(!viz[A[nod][i]])
        {
            T[A[nod][i]] = nod;
            DF(A[nod][i]);
        }
}

inline void flip(int a)
{
    Val[a] = 1-Val[a];
}

void creareArbore(void)
{
    for(int i=2;i<=N;i++)
        B[T[i]].push_back(i);
}

inline int first_try(int a)
{
    int i;

    if(Val[a] == 1)
        return -a;

    for(i=a;B[i].size() == 1;i=B[i][0])
        if(Val[i] == 1)
            return -i;

    return i; 
}

inline int query(int a,int b)
{
    int i,answer = -1;

    a = first_try(a);
    if(a < 0)
        return -a;

    for(i = b;i != a && i != 0;i = T[i])
        if(Val[i] == 1)
            answer = i;
    if(Val[a] == 1)
        answer = a;

    assert(i != 0);

    return answer;
}

int main() 
{
    int op,a,b;

    assert(freopen("confuzie.in", "rt", stdin));
#ifndef DEBUG
    assert(freopen("confuzie.out", "wt", stdout));
#endif

    citire();

    assert(1 <= N <= 250000);

    viz[1] = 1;
    creareArbore();
    DF(1);

    for(int i=1;i<=Q;i++)
    {
        scanf("%d ",&op);
        switch(op)
        {
            case 0 : scanf("%d ",&a);
                     assert(1 <= a && a <= N);
                     flip(a);
                break;
            case 1 : scanf("%d %d",&a,&b);
                     assert(1 <= a && a <= N);
                     assert(1 <= b && b <= N);
                     printf("%d\n",query(a,b));
                break;
        }
    }

    return 0;
}
