/* (C) 2013 Bogdan Cristian Tataroiu */

#include <stdio.h>
#include <string.h>
#include <assert.h>

#define MAXN 100
#define MAXM 1000
#define MAXC 1000000

int N, cnt[MAXC], cntMult[MAXC];

inline int min(int a, int b) {
    if (a < b) {
        return a;
    }
    return b;
}

int main() {
    assert(freopen("ausoara.in", "rt", stdin));
    assert(freopen("ausoara.out", "wt", stdout));

    int i, j;
    assert(scanf("%d", &N) == 1);
    assert(1 <= N && N <= MAXN);
    int maxVal = 0;
    for (i = 0; i < N; i++) {
        int M;
        assert(scanf("%d", &M) == 1);
        assert(1 <= M && M <= MAXM);

        if (maxVal > 0) {
            memset(cntMult, 0, sizeof(int) * maxVal);
        }
        for (j = 0; j < M; j++) {
            int val;
            assert(scanf("%d", &val) == 1);
            for (; maxVal <= val - 1; maxVal++) {
                if (i == 0) {
                    cnt[maxVal] = 0x3f3f3f3f;
                } else {
                    cnt[maxVal] = 0;
                }
                cntMult[maxVal] = 0;
            }
            assert(1 <= val && val <= MAXC);
            cntMult[val - 1] += 1;
        }

        for (j = 0; j < maxVal; j++) {
            cnt[j] = min(cnt[j], cntMult[j]);
        }
    }

    int CNT = 0;
    for (i = 0; i < maxVal; i++) {
        CNT += cnt[i];
    }
    printf("%d", CNT);
    for (i = 0; i < maxVal; i++) {
        for (; cnt[i]; cnt[i]--) {
            printf(" %d", i + 1);
        }
    }
    printf("\n");

    return 0;
}
