// O(N) - 100 puncte
//
// Copyright Lambru Andrei Cristian
// Universitatea Bucuresti
Program banal;

var A:array[1..1000000] of longint;
	SolV:array[1..1000000] of longint;
	Sol,T,N:integer;
	f:text;
 
procedure citire;
var i:integer;
begin
	read(f,N);

	for i := 1 to N do
		read(f,A[i]);
end;

procedure afisare;
var i:integer;
	g:text;
begin
	assign(g,'ausoara.out'); rewrite(g);

	write(g,Sol,' ');

	for i := 1 to Sol do
		write(g,SolV[i],' ');
	
	close(g);
end;

procedure interclasare;
var i,j,poz:integer;
begin
	i := 1; j := 1; poz := 0;
	
	while (i <= N)  and (j <= Sol) do
	begin
		if SolV[j] = A[i] then 
		begin 
			poz := poz + 1;
			SolV[poz] := SolV[j];
			j := j + 1;
			i := i + 1;
		end
		else
		begin
			while (SolV[j] < A[i]) and (j <= Sol) do
				j := j + 1;
			if(SolV[j] <> A[i]) then
				i := i + 1;
		end;
	end;
	
	Sol := poz;
end;

procedure Rezolvare;
var i:integer;
begin
	readln(f,T);

	citire();
	
	Sol := N;
	for i := 1 to Sol do 
		SolV[i] := A[i];
	
	for i := 2 to T do
	begin
		citire();
		interclasare();
	end; 
	
end;

begin
	assign(f,'ausoara.in'); reset(f);
	
	Rezolvare;
	
	afisare;
	
	close(f);
end.
