#include <cstdio>
#include <cassert>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

const int MOD = 666013;

using namespace std;

vector <int> A;
long long N;
int X, K;
int d[2][1000000];

int main() {
    
    ifstream fin("xnumere.in");
    ofstream fout("xnumere.out");

    fin >> K >> X >> N;
    assert(N <= 10000);
    assert(K <= 100);

    d[0][0] = 1;    

    for(int i = 1; i <= N; ++i) {
	
	//clear
	for(int j = 0; j <= K; ++j)
	    d[1][j] = 0;
	// ~clear

	for(int j = 1; j <= K; ++j) {
	    d[1][j] = (1LL * d[0][j] * j) % MOD + (1LL * (K - j + 1) * d[0][j - 1]) % MOD ;
	    if(d[1][j] >= MOD)
		d[1][j] %= MOD;
	}
	//copy
	for(int j = 0; j <= K; ++j)
	    d[0][j] = d[1][j] ;
	//~copy
    }
    
    fout << d[1][X] << "\n";
    return 0;
}
